Index: /branches/HTM-4.1-dev2-LG/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/HTM-4.1-dev2-LG/source/App/TAppEncoder/TAppEncTop.cpp	(revision 155)
+++ /branches/HTM-4.1-dev2-LG/source/App/TAppEncoder/TAppEncTop.cpp	(revision 156)
@@ -301,5 +301,5 @@
     m_acTEncTopList[iViewIdx]->setUseSAO               ( m_abUseSAO[0]     );
 #if LGE_ILLUCOMP_B0045
-  m_acTEncTopList[iViewIdx]->setUseIC                ( m_bUseIC          );
+    m_acTEncTopList[iViewIdx]->setUseIC                ( m_bUseIC          );
 #endif
 #if SAO_UNIT_INTERLEAVING
@@ -583,5 +583,5 @@
       m_acTEncDepthTopList[iViewIdx]->setUseSAO               ( m_abUseSAO[1]     );
 #if LGE_ILLUCOMP_B0045
-    m_acTEncDepthTopList[iViewIdx]->setUseIC                ( false     );
+      m_acTEncDepthTopList[iViewIdx]->setUseIC                ( false     );
 #endif
 #if SAO_UNIT_INTERLEAVING
Index: /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/ContextTables.h
===================================================================
--- /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/ContextTables.h	(revision 155)
+++ /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/ContextTables.h	(revision 156)
@@ -187,5 +187,5 @@
 #if LGE_ILLUCOMP_B0045
 static const UChar 
-  INIT_IC_FLAG[3][NUM_IC_FLAG_CTX] =  
+INIT_IC_FLAG[3][NUM_IC_FLAG_CTX] =  
 {
   { CNU,  CNU,  CNU, }, 
Index: /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/TComDataCU.cpp	(revision 155)
+++ /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/TComDataCU.cpp	(revision 156)
@@ -213,5 +213,5 @@
     m_pbMergeFlag        = (Bool*  )xMalloc(Bool,   uiNumPartition);
 #if LGE_ILLUCOMP_B0045
-  m_pbICFlag           = (Bool*  )xMalloc(Bool,   uiNumPartition);
+    m_pbICFlag           = (Bool*  )xMalloc(Bool,   uiNumPartition);
 #endif
     m_puhMergeIndex      = (UChar* )xMalloc(UChar,  uiNumPartition);
@@ -362,5 +362,5 @@
     if ( m_pbMergeFlag        ) { xFree(m_pbMergeFlag);         m_pbMergeFlag       = NULL; }
 #if LGE_ILLUCOMP_B0045
-  if ( m_pbICFlag           ) { xFree(m_pbICFlag);            m_pbICFlag          = NULL; }
+    if ( m_pbICFlag           ) { xFree(m_pbICFlag);            m_pbICFlag          = NULL; }
 #endif
     if ( m_puhMergeIndex      ) { xFree(m_puhMergeIndex);       m_puhMergeIndex     = NULL; }
@@ -558,5 +558,5 @@
     m_pbMergeFlag[ui]=pcFrom->m_pbMergeFlag[ui];
 #if LGE_ILLUCOMP_B0045
-  m_pbICFlag[ui]=pcFrom->m_pbICFlag[ui];
+    m_pbICFlag[ui]=pcFrom->m_pbICFlag[ui];
 #endif
     m_puhMergeIndex[ui]=pcFrom->m_puhMergeIndex[ui];
@@ -593,5 +593,5 @@
     memset( m_pbMergeFlag       + firstElement, false,                    numElements * sizeof( *m_pbMergeFlag ) );
 #if LGE_ILLUCOMP_B0045
-  memset( m_pbICFlag          + firstElement, false,                    numElements * sizeof( *m_pbICFlag ) );
+    memset( m_pbICFlag          + firstElement, false,                    numElements * sizeof( *m_pbICFlag ) );
 #endif
     memset( m_puhMergeIndex     + firstElement, 0,                        numElements * sizeof( *m_puhMergeIndex ) );
@@ -779,5 +779,5 @@
       m_pbMergeFlag[ui] = 0;
 #if LGE_ILLUCOMP_B0045
-    m_pbICFlag[ui]    = false;
+      m_pbICFlag[ui]    = false;
 #endif
       m_puhMergeIndex[ui] = 0;
@@ -961,5 +961,5 @@
       m_pbMergeFlag[ui]=pcCU->m_pbMergeFlag[uiPartOffset+ui];
 #if LGE_ILLUCOMP_B0045
-    m_pbICFlag[ui]=pcCU->m_pbICFlag[uiPartOffset+ui];
+      m_pbICFlag[ui]=pcCU->m_pbICFlag[uiPartOffset+ui];
 #endif
       m_puhMergeIndex[ui]=pcCU->m_puhMergeIndex[uiPartOffset+ui];
Index: /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/TComPrediction.cpp	(revision 155)
+++ /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/TComPrediction.cpp	(revision 156)
@@ -629,5 +629,5 @@
     {
 #if LGE_ILLUCOMP_B0045
-    if( pcCU->getSlice()->getPPS()->getUseWP() && !pcCU->getICFlag(uiPartAddr))
+      if( pcCU->getSlice()->getPPS()->getUseWP() && !pcCU->getICFlag(uiPartAddr))
 #else
       if( pcCU->getSlice()->getPPS()->getUseWP())
@@ -649,5 +649,5 @@
       }
 #if LGE_ILLUCOMP_B0045
-    if( pcCU->getSlice()->getPPS()->getUseWP() && !pcCU->getICFlag(uiPartAddr) )
+      if( pcCU->getSlice()->getPPS()->getUseWP() && !pcCU->getICFlag(uiPartAddr) )
 #else
       if ( pcCU->getSlice()->getPPS()->getUseWP() )
@@ -698,5 +698,5 @@
     {
 #if LGE_ILLUCOMP_B0045
-    if( pcCU->getSlice()->getPPS()->getUseWP() && !pcCU->getICFlag(uiPartAddr))
+      if( pcCU->getSlice()->getPPS()->getUseWP() && !pcCU->getICFlag(uiPartAddr))
 #else
       if( pcCU->getSlice()->getPPS()->getUseWP())
@@ -723,5 +723,5 @@
 #endif  
 #if LGE_ILLUCOMP_B0045
-    if( pcCU->getSlice()->getPPS()->getUseWP() && !pcCU->getICFlag(uiPartAddr))
+      if( pcCU->getSlice()->getPPS()->getUseWP() && !pcCU->getICFlag(uiPartAddr))
 #else
       if ( pcCU->getSlice()->getPPS()->getUseWP() )
Index: /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/TComSlice.cpp	(revision 155)
+++ /branches/HTM-4.1-dev2-LG/source/Lib/TLibCommon/TComSlice.cpp	(revision 156)
@@ -1370,10 +1370,8 @@
       iSumOrgSAD += abs(aiCurrHist[i] - aiRefOrgHist[i]);
     }
-    //printf("iSumOrgSAD : %d\n",iSumOrgSAD);
     // Setting
     if ( iSumOrgSAD > Int(dThresholdOrgSAD * iWidth * iHeight) )
     {
       m_bApplyIC = true;
-      //printf("ApplyIC\n");
     }
     else
Index: /branches/HTM-4.1-dev2-LG/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- /branches/HTM-4.1-dev2-LG/source/Lib/TLibDecoder/TDecCu.cpp	(revision 155)
+++ /branches/HTM-4.1-dev2-LG/source/Lib/TLibDecoder/TDecCu.cpp	(revision 156)
@@ -390,5 +390,5 @@
     }
 #if LGE_ILLUCOMP_B0045
-  m_pcEntropyDecoder->decodeICFlag( pcCU, uiAbsPartIdx, uiDepth );
+    m_pcEntropyDecoder->decodeICFlag( pcCU, uiAbsPartIdx, uiDepth );
 #endif
 #if HHI_MPI
Index: /branches/HTM-4.1-dev2-LG/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-4.1-dev2-LG/source/Lib/TLibEncoder/TEncCu.cpp	(revision 155)
+++ /branches/HTM-4.1-dev2-LG/source/Lib/TLibEncoder/TEncCu.cpp	(revision 156)
@@ -735,8 +735,8 @@
           Bool bResPredFlag  = ( uiResPrdId > 0 );
 #if LGE_ILLUCOMP_B0045
-      for(UInt uiICId = 0; uiICId < (bICEnabled ? 2 : 1); uiICId++)
-      {
-        Bool bICFlag = (uiICId ? true : false);
-        rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
+          for(UInt uiICId = 0; uiICId < (bICEnabled ? 2 : 1); uiICId++)
+          {
+            Bool bICFlag = (uiICId ? true : false);
+            rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
 #endif
 #endif
@@ -763,9 +763,9 @@
           }
 #if LGE_ILLUCOMP_B0045_ENCSIMP
-      if(bICFlag && rpcBestCU->getMergeFlag(0) && !rpcBestCU->getICFlag(0))
-      {
-        bICEnabled = false;
-        break;
-      }
+          if(bICFlag && rpcBestCU->getMergeFlag(0) && !rpcBestCU->getICFlag(0))
+          {
+             bICEnabled = false;
+             break;
+          }
 #endif
           // 2Nx2N, NxN
@@ -788,5 +788,5 @@
           }
 #if LGE_ILLUCOMP_B0045
-      }
+         }
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -877,8 +877,8 @@
           Bool bResPredFlag  = ( uiResPrdId > 0 );
 #if LGE_ILLUCOMP_B0045
-      for(UInt uiICId = 0; uiICId < (bICEnabled ? 2 : 1); uiICId++)
-      {
-        Bool bICFlag = (uiICId ? true : false);
-        rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
+          for(UInt uiICId = 0; uiICId < (bICEnabled ? 2 : 1); uiICId++)
+          {
+            Bool bICFlag = (uiICId ? true : false);
+            rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
 #endif
 #endif
@@ -1418,5 +1418,5 @@
 #endif
 #if LGE_ILLUCOMP_B0045
-    }
+         }
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -1446,5 +1446,5 @@
         {
 #if LGE_ILLUCOMP_B0045
-      rpcTempCU->setICFlagSubParts(false, 0, 0, uiDepth);
+          rpcTempCU->setICFlagSubParts(false, 0, 0, uiDepth);
 #endif
           xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
@@ -1466,5 +1466,5 @@
                 {
 #if LGE_ILLUCOMP_B0045
-          rpcTempCU->setICFlagSubParts(false, 0, 0, uiDepth);
+                  rpcTempCU->setICFlagSubParts(false, 0, 0, uiDepth);
 #endif
                   xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_NxN   );
@@ -1502,5 +1502,5 @@
         {
 #if LGE_ILLUCOMP_B0045
-      rpcTempCU->setICFlagSubParts(false, 0, 0, uiDepth);
+          rpcTempCU->setICFlagSubParts(false, 0, 0, uiDepth);
 #endif
           xCheckIntraPCM (rpcBestCU, rpcTempCU);
@@ -2148,5 +2148,5 @@
     m_pcEntropyCoder->encodeMergeIndex( pcCU, uiAbsPartIdx, 0 );
 #if LGE_ILLUCOMP_B0045
-  m_pcEntropyCoder->encodeICFlag  ( pcCU, uiAbsPartIdx );
+    m_pcEntropyCoder->encodeICFlag  ( pcCU, uiAbsPartIdx );
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -2179,5 +2179,5 @@
   m_pcEntropyCoder->encodePredInfo( pcCU, uiAbsPartIdx );
 #if LGE_ILLUCOMP_B0045
-  m_pcEntropyCoder->encodeICFlag  ( pcCU, uiAbsPartIdx );
+    m_pcEntropyCoder->encodeICFlag  ( pcCU, uiAbsPartIdx );
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -2303,5 +2303,5 @@
 #endif
 #if LGE_ILLUCOMP_B0045
-      rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uhDepth);
+          rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uhDepth);
 #endif
 
@@ -3218,5 +3218,5 @@
     m_pcEntropyCoder->encodeMergeIndex( pcCU, 0, 0, true );
 #if LGE_ILLUCOMP_B0045
-  m_pcEntropyCoder->encodeICFlag( pcCU, 0, true );
+    m_pcEntropyCoder->encodeICFlag( pcCU, 0, true );
 #endif
   }
@@ -3228,5 +3228,5 @@
     m_pcEntropyCoder->encodePredInfo( pcCU, 0, true );
 #if LGE_ILLUCOMP_B0045
-  m_pcEntropyCoder->encodeICFlag( pcCU, 0,          true );
+    m_pcEntropyCoder->encodeICFlag( pcCU, 0,          true );
 #endif
   }
Index: /branches/HTM-4.1-dev2-LG/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- /branches/HTM-4.1-dev2-LG/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 155)
+++ /branches/HTM-4.1-dev2-LG/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 156)
@@ -231,5 +231,5 @@
       curCost += m_cCUSkipFlagSCModel.calcCost        ( curSliceType, qp, (UChar*)INIT_SKIP_FLAG );
 #if LGE_ILLUCOMP_B0045
-    curCost += m_cCUICFlagSCModel.calcCost          ( curSliceType, qp, (UChar*)INIT_IC_FLAG );
+      curCost += m_cCUICFlagSCModel.calcCost          ( curSliceType, qp, (UChar*)INIT_IC_FLAG );
 #endif
       curCost += m_cCUAlfCtrlFlagSCModel.calcCost     ( curSliceType, qp, (UChar*)INIT_ALF_CTRL_FLAG );
Index: /branches/HTM-4.1-dev2-LG/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- /branches/HTM-4.1-dev2-LG/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 155)
+++ /branches/HTM-4.1-dev2-LG/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 156)
@@ -721,5 +721,5 @@
     m_cDistParam.pCur = piRefPos;
 #if LGE_ILLUCOMP_B0045
-  m_cDistParam.bUseIC = pcPatternKey->getICFlag();
+    m_cDistParam.bUseIC = pcPatternKey->getICFlag();
 #endif
     uiDist = m_cDistParam.DistFunc( &m_cDistParam );
@@ -4124,5 +4124,5 @@
 
 #if LGE_ILLUCOMP_B0045
-    m_cDistParam.bUseIC = pcPatternKey->getICFlag();
+      m_cDistParam.bUseIC = pcPatternKey->getICFlag();
 #endif
       uiSad = m_cDistParam.DistFunc( &m_cDistParam );
@@ -4483,5 +4483,5 @@
     m_pcEntropyCoder->encodeMergeIndex( pcCU, 0, 0, true );
 #if LGE_ILLUCOMP_B0045
-  m_pcEntropyCoder->encodeICFlag(pcCU, 0, true);
+    m_pcEntropyCoder->encodeICFlag(pcCU, 0, true);
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -5851,5 +5851,5 @@
     m_pcEntropyCoder->encodeMergeIndex(pcCU, 0, 0, true);
 #if LGE_ILLUCOMP_B0045
-  m_pcEntropyCoder->encodeICFlag(pcCU, 0, true);
+    m_pcEntropyCoder->encodeICFlag(pcCU, 0, true);
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -5874,5 +5874,5 @@
     m_pcEntropyCoder->encodePredInfo( pcCU, 0, true );
 #if LGE_ILLUCOMP_B0045
-  m_pcEntropyCoder->encodeICFlag(pcCU, 0, true);
+    m_pcEntropyCoder->encodeICFlag(pcCU, 0, true);
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED