Index: /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComPic.cpp	(revision 161)
+++ /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComPic.cpp	(revision 162)
@@ -116,27 +116,4 @@
   return;
 }
-#if REF_IDX_FRAMEWORK && 0
-Void TComPic::createWithOutYuv( Int iWidth, Int iHeight, UInt uiMaxWidth, UInt uiMaxHeight, UInt uiMaxDepth, TComSPS* pcSps,  Bool bIsVirtual)
-{
-  m_apcPicSym     = new TComPicSym;  m_apcPicSym   ->create( iWidth, iHeight, uiMaxWidth, uiMaxHeight, uiMaxDepth );
-  if (!bIsVirtual)
-  {
-    m_apcPicYuv[0]  = new TComPicYuv;  m_apcPicYuv[0]->create( iWidth, iHeight, uiMaxWidth, uiMaxHeight, uiMaxDepth, pcSps );
-  }
-  m_apcPicYuv[1]  = NULL;
- 
-#if SVC_UPSAMPLING
-  if (m_bSpatialEnhLayer)
-  {
-    m_pcFullPelBaseRec = new TComPicYuv;  m_pcFullPelBaseRec->create( iWidth, iHeight, uiMaxWidth, uiMaxHeight, uiMaxDepth, pcSps );
-  }
-#endif
-
-  /* there are no SEI messages associated with this picture initially */
-  m_SEIs.clear();
-  m_bUsedByCurr = false;
-  return;
-}
-#endif
 #else
 Void TComPic::create( Int iWidth, Int iHeight, UInt uiMaxWidth, UInt uiMaxHeight, UInt uiMaxDepth, Window &conformanceWindow, Window &defaultDisplayWindow,
@@ -654,7 +631,5 @@
   }
 }
-#endif
-
-#if RAP_MFM_INIT
+
 Void TComPic::initUpsampledMvField()
 {
Index: /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComPic.h
===================================================================
--- /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComPic.h	(revision 161)
+++ /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComPic.h	(revision 162)
@@ -103,8 +103,4 @@
   Void          create( Int iWidth, Int iHeight, UInt uiMaxWidth, UInt uiMaxHeight, UInt uiMaxDepth, Window &conformanceWindow, Window &defaultDisplayWindow, 
                         Int *numReorderPics, TComSPS* pcSps = NULL, Bool bIsVirtual = false );
-#if REF_IDX_FRAMEWORK && 0
-  Void          createWithOutYuv( Int iWidth, Int iHeight, UInt uiMaxWidth, UInt uiMaxHeight, UInt uiMaxDepth, TComSPS* pcSps = NULL, Bool bIsVirtual = false );  
-  Void          setPicYuvRec(TComPicYuv *pPicYuv) { m_apcPicYuv[1]=pPicYuv; }
-#endif
 #else
   Void          create( Int iWidth, Int iHeight, UInt uiMaxWidth, UInt uiMaxHeight, UInt uiMaxDepth, Window &conformanceWindow, Window &defaultDisplayWindow, 
@@ -129,7 +125,5 @@
 #if REF_IDX_MFM
   Void          copyUpsampledMvField  (  TComPic* pcPicBase );
-#if RAP_MFM_INIT
   Void          initUpsampledMvField  ();
-#endif
 #endif
 
Index: /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 161)
+++ /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 162)
@@ -123,5 +123,5 @@
 #endif
   
-#if REF_LIST_BUGFIX
+#if REF_IDX_FRAMEWORK
   m_aiNumILRRefIdx = 0;
 #endif
@@ -174,5 +174,5 @@
   m_aiNumRefIdx[0]      = 0;
   m_aiNumRefIdx[1]      = 0;
-#if REF_LIST_BUGFIX
+#if REF_IDX_FRAMEWORK
   if(layerId)
   {
@@ -425,5 +425,5 @@
 
 #if FIX1071
-Void TComSlice::setRefPicList( TComList<TComPic*>& rcListPic, Bool checkNumPocTotalCurr )
+Void TComSlice::setRefPicList( TComList<TComPic*>& rcListPic, Bool checkNumPocTotalCurr, TComPic** ilpPic)
 #else
 Void TComSlice::setRefPicList( TComList<TComPic*>& rcListPic )
@@ -434,20 +434,13 @@
 #endif
   {
-#if REF_IDX_FRAMEWORK
-  if( m_eSliceType == I_SLICE || ( getSPS()->getLayerId() && 
-      (getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP) &&
-      (getNalUnitType() <= NAL_UNIT_CODED_SLICE_CRA) ) )
-#else
-  if (m_eSliceType == I_SLICE)
-#endif
-  {
-    ::memset( m_apcRefPicList, 0, sizeof (m_apcRefPicList));
-    ::memset( m_aiNumRefIdx,   0, sizeof ( m_aiNumRefIdx ));
-    
-    return;
-  }
+    if( m_eSliceType == I_SLICE )
+    {
+      ::memset( m_apcRefPicList, 0, sizeof (m_apcRefPicList));
+      ::memset( m_aiNumRefIdx,   0, sizeof ( m_aiNumRefIdx ));
+      return;
+    }
   
-  m_aiNumRefIdx[0] = getNumRefIdx(REF_PIC_LIST_0);
-  m_aiNumRefIdx[1] = getNumRefIdx(REF_PIC_LIST_1);
+    m_aiNumRefIdx[0] = getNumRefIdx(REF_PIC_LIST_0);
+    m_aiNumRefIdx[1] = getNumRefIdx(REF_PIC_LIST_1);
   }
 
@@ -461,4 +454,11 @@
   Int i;
 
+#if REF_IDX_FRAMEWORK
+  if ((getLayerId() == 0) || 
+      ((getSPS()->getLayerId()) &&  !((getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP) &&
+       (getNalUnitType() <= NAL_UNIT_CODED_SLICE_CRA)) )
+     )
+  {
+#endif
   for(i=0; i < m_pcRPS->getNumberOfNegativePictures(); i++)
   {
@@ -503,9 +503,33 @@
     pcRefPic->setCheckLTMSBPresent(m_pcRPS->getCheckLTMSBPresent(i));  
   }
-
+#if REF_IDX_FRAMEWORK
+  }
+#endif
+
+#if REF_IDX_FRAMEWORK
+  //inter-layer reference picture
+#if REF_IDX_MFM
+  if (getLayerId())
+  {
+    if(!(getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP && getNalUnitType() <= NAL_UNIT_CODED_SLICE_CRA) && getSPS()->getMFMEnabledFlag())
+    { 
+      ilpPic[0]->copyUpsampledMvField(getBaseColPic());
+    }
+    else
+    {
+      ilpPic[0]->initUpsampledMvField();
+    }
+  #endif
+    ilpPic[0]->setIsLongTerm(1);
+  }
+#endif
   // ref_pic_list_init
   TComPic*  rpsCurrList0[MAX_NUM_REF+1];
   TComPic*  rpsCurrList1[MAX_NUM_REF+1];
+#if REF_IDX_FRAMEWORK
+  Int numPocTotalCurr = NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr + m_aiNumILRRefIdx;
+#else
   Int numPocTotalCurr = NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr;
+#endif
 #if FIX1071
   if (checkNumPocTotalCurr)
@@ -547,5 +571,13 @@
       rpsCurrList0[cIdx] = RefPicSetLtCurr[i];
     }
-
+#if REF_IDX_FRAMEWORK
+    if(getLayerId())
+    {
+      for( i = 0; i < m_aiNumILRRefIdx && cIdx < numPocTotalCurr; cIdx ++, i ++)
+      {
+        rpsCurrList0[cIdx] = ilpPic[i];
+      }
+    }
+#endif
   if (m_eSliceType==B_SLICE)
   {
@@ -563,4 +595,13 @@
       rpsCurrList1[cIdx] = RefPicSetLtCurr[i];
     }
+#if REF_IDX_FRAMEWORK
+    if(getLayerId())
+    {
+      for( i = 0; i < m_aiNumILRRefIdx && cIdx < numPocTotalCurr; cIdx ++, i ++)
+      {
+        rpsCurrList1[cIdx] = ilpPic[i];
+      }
+    }
+#endif
   }
 
@@ -589,5 +630,5 @@
 }
 
-#if REF_LIST_BUGFIX
+#if REF_IDX_FRAMEWORK
 Void TComSlice::setRefPicListModificationSvc()
 {
@@ -659,165 +700,4 @@
     }
   }
-  return;
-}
-
-Void TComSlice::setRefPicListSvc( TComList<TComPic*>& rcListPic, TComPic** ilpPic )
-{
-  assert(getLayerId() > 0);
-
-  m_aiNumRefIdx[0] = getNumRefIdx(REF_PIC_LIST_0);
-  m_aiNumRefIdx[1] = getNumRefIdx(REF_PIC_LIST_1);
-
-  TComPic*  pcRefPic= NULL;
-  TComPic*  RefPicSetStCurr0[16];
-  TComPic*  RefPicSetStCurr1[16];
-  TComPic*  RefPicSetLtCurr[16];
-  UInt NumPocStCurr0 = 0;
-  UInt NumPocStCurr1 = 0;
-  UInt NumPocLtCurr = 0;
-  Int i;
-
-  //temporal reference pictures
-  if( !(getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP && getNalUnitType() <= NAL_UNIT_CODED_SLICE_CRA) )
-  { 
-    for(i=0; i < m_pcRPS->getNumberOfNegativePictures(); i++)
-    {
-      if(m_pcRPS->getUsed(i))
-      {
-        pcRefPic = xGetRefPic(rcListPic, getPOC()+m_pcRPS->getDeltaPOC(i));
-        pcRefPic->setIsLongTerm(0);
-        pcRefPic->getPicYuvRec()->extendPicBorder();
-        RefPicSetStCurr0[NumPocStCurr0] = pcRefPic;
-        NumPocStCurr0++;
-        pcRefPic->setCheckLTMSBPresent(false);  
-      }
-    }
-    for(; i < m_pcRPS->getNumberOfNegativePictures()+m_pcRPS->getNumberOfPositivePictures(); i++)
-    {
-      if(m_pcRPS->getUsed(i))
-      {
-        pcRefPic = xGetRefPic(rcListPic, getPOC()+m_pcRPS->getDeltaPOC(i));
-        pcRefPic->setIsLongTerm(0);
-        pcRefPic->getPicYuvRec()->extendPicBorder();
-        RefPicSetStCurr1[NumPocStCurr1] = pcRefPic;
-        NumPocStCurr1++;
-        pcRefPic->setCheckLTMSBPresent(false);  
-      }
-    }
-    for(i = m_pcRPS->getNumberOfNegativePictures()+m_pcRPS->getNumberOfPositivePictures()+m_pcRPS->getNumberOfLongtermPictures()-1; i > m_pcRPS->getNumberOfNegativePictures()+m_pcRPS->getNumberOfPositivePictures()-1 ; i--)
-    {
-      if(m_pcRPS->getUsed(i))
-      {
-        pcRefPic = xGetLongTermRefPic(rcListPic, m_pcRPS->getPOC(i), m_pcRPS->getCheckLTMSBPresent(i));
-        pcRefPic->setIsLongTerm(1);
-        pcRefPic->getPicYuvRec()->extendPicBorder();
-        RefPicSetLtCurr[NumPocLtCurr] = pcRefPic;
-        NumPocLtCurr++;
-      }
-      if(pcRefPic==NULL) 
-      {
-        pcRefPic = xGetLongTermRefPic(rcListPic, m_pcRPS->getPOC(i), m_pcRPS->getCheckLTMSBPresent(i));
-      }
-      pcRefPic->setCheckLTMSBPresent(m_pcRPS->getCheckLTMSBPresent(i));  
-    }
-  }
-
-  //inter-layer reference picture
-#if REF_IDX_MFM
-  assert(m_aiNumILRRefIdx == 1);
-  if(!(getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP && getNalUnitType() <= NAL_UNIT_CODED_SLICE_CRA) && getSPS()->getMFMEnabledFlag())
-  { 
-    ilpPic[0]->copyUpsampledMvField(getBaseColPic());
-  }
-  else
-  {
-    ilpPic[0]->initUpsampledMvField();
-  }
-#endif
-  ilpPic[0]->setIsLongTerm(1);
-
-  // ref_pic_list_init
-  UInt cIdx = 0;
-  UInt num_ref_idx_l0_active_minus1 = m_aiNumRefIdx[0] - 1;
-  UInt num_ref_idx_l1_active_minus1 = m_aiNumRefIdx[1] - 1;
-  TComPic*  refPicListTemp0[MAX_NUM_REF+1];
-  TComPic*  refPicListTemp1[MAX_NUM_REF+1];
-  Int  numRpsCurrTempList0, numRpsCurrTempList1;
-
-  numRpsCurrTempList0 = numRpsCurrTempList1 = NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr + m_aiNumILRRefIdx;
-  if (numRpsCurrTempList0 <= num_ref_idx_l0_active_minus1)
-  {
-    numRpsCurrTempList0 = num_ref_idx_l0_active_minus1 + 1;
-  }
-  if (numRpsCurrTempList1 <= num_ref_idx_l1_active_minus1)
-  {
-    numRpsCurrTempList1 = num_ref_idx_l1_active_minus1 + 1;
-  }
-
-  assert(numRpsCurrTempList0 <= MAX_NUM_REF);
-  assert(numRpsCurrTempList1 <= MAX_NUM_REF);
-
-  cIdx = 0;
-  while (cIdx < numRpsCurrTempList0)
-  { 
-    for ( i=0; i<NumPocStCurr0 && cIdx<numRpsCurrTempList0; cIdx++,i++) 
-    {
-      refPicListTemp0[cIdx] = RefPicSetStCurr0[ i ];
-    }
-    for ( i=0; i<NumPocStCurr1 && cIdx<numRpsCurrTempList0; cIdx++,i++)
-    {
-      refPicListTemp0[cIdx] = RefPicSetStCurr1[ i ];
-    }
-    for ( i=0; i<NumPocLtCurr && cIdx<numRpsCurrTempList0; cIdx++,i++)
-    {
-      refPicListTemp0[cIdx] = RefPicSetLtCurr[ i ];
-    }
-    for ( i=0; i<m_aiNumILRRefIdx && cIdx<numRpsCurrTempList0; cIdx++,i++)
-    {
-      refPicListTemp0[cIdx] = ilpPic[ i ];
-    }
-  }
-  cIdx = 0;
-  while (cIdx<numRpsCurrTempList1 && m_eSliceType==B_SLICE)
-  { 
-    for ( i=0; i<NumPocStCurr1 && cIdx<numRpsCurrTempList1; cIdx++,i++)
-    {
-      refPicListTemp1[cIdx] = RefPicSetStCurr1[ i ];
-    }
-    for ( i=0; i<NumPocStCurr0 && cIdx<numRpsCurrTempList1; cIdx++,i++)
-    {
-      refPicListTemp1[cIdx] = RefPicSetStCurr0[ i ];
-    }
-    for ( i=0; i<NumPocLtCurr && cIdx<numRpsCurrTempList1; cIdx++,i++)
-    {
-      refPicListTemp1[cIdx] = RefPicSetLtCurr[ i ];
-    }
-    for ( i=0; i<m_aiNumILRRefIdx && cIdx<numRpsCurrTempList1; cIdx++,i++)
-    {
-      refPicListTemp1[cIdx] = ilpPic[ i ];
-    }
-  }
-  ::memset(m_bIsUsedAsLongTerm, 0, sizeof(m_bIsUsedAsLongTerm));
-  for (Int rIdx = 0; rIdx <= (m_aiNumRefIdx[0]-1); rIdx ++)
-  {
-    m_apcRefPicList[0][rIdx] = m_RefPicListModification.getRefPicListModificationFlagL0() ? refPicListTemp0[ m_RefPicListModification.getRefPicSetIdxL0(rIdx) ] : refPicListTemp0[rIdx % numRpsCurrTempList0];
-    m_bIsUsedAsLongTerm[0][rIdx] = m_RefPicListModification.getRefPicListModificationFlagL0() ? (m_RefPicListModification.getRefPicSetIdxL0(rIdx) >= (NumPocStCurr0 + NumPocStCurr1))
-      : ((rIdx % numRpsCurrTempList0) >= (NumPocStCurr0 + NumPocStCurr1));
-  }
-  if ( m_eSliceType == P_SLICE )
-  {
-    m_aiNumRefIdx[1] = 0;
-    ::memset( m_apcRefPicList[1], 0, sizeof(m_apcRefPicList[1]));
-  }
-  else
-  {
-    for (Int rIdx = 0; rIdx <= (m_aiNumRefIdx[1]-1); rIdx ++)
-    {
-      m_apcRefPicList[1][rIdx] = m_RefPicListModification.getRefPicListModificationFlagL1() ? refPicListTemp1[ m_RefPicListModification.getRefPicSetIdxL1(rIdx) ] : refPicListTemp1[rIdx % numRpsCurrTempList1];
-      m_bIsUsedAsLongTerm[1][rIdx] = m_RefPicListModification.getRefPicListModificationFlagL1() ?
-        (m_RefPicListModification.getRefPicSetIdxL1(rIdx) >= (NumPocStCurr0 + NumPocStCurr1)): ((rIdx % numRpsCurrTempList1) >= (NumPocStCurr0 + NumPocStCurr1));
-    }
-  }
-
   return;
 }
@@ -836,5 +716,5 @@
 #endif 
   {
-#if REF_LIST_BUGFIX
+#if REF_IDX_FRAMEWORK
     return m_aiNumILRRefIdx;
 #else
@@ -849,5 +729,5 @@
     }
   }
-#if REF_LIST_BUGFIX
+#if REF_IDX_FRAMEWORK
   if(getLayerId())
   {
@@ -2575,54 +2455,4 @@
 #endif 
 
-#if REF_IDX_FRAMEWORK
-Void TComSlice::addRefPicList( TComPic **pIlpPicList, Int iRefPicNum, Int iInsertOffset )
-{
-  if(getSPS()->getLayerId() && m_eSliceType != I_SLICE)
-  {
-#if REF_IDX_MFM
-    assert(iRefPicNum == 1);
-#if RAP_MFM_INIT
-    if(!(getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP && getNalUnitType() <= NAL_UNIT_CODED_SLICE_CRA) && getSPS()->getMFMEnabledFlag())
-#else
-    if( getPOC() != 0 )
-#endif
-    { 
-      pIlpPicList[0]->copyUpsampledMvField(getBaseColPic());
-    }
-#if RAP_MFM_INIT
-    else
-    {
-      pIlpPicList[0]->initUpsampledMvField();
-    }
-#endif
-#endif
-    //add to list 0;
-    Int iOffset;
-    m_aiNumRefIdx[REF_PIC_LIST_0] += iInsertOffset;
-    iOffset = m_aiNumRefIdx[REF_PIC_LIST_0];
-    for (Int i=0; i<iRefPicNum; i++)
-    {
-      pIlpPicList[i]->setIsLongTerm(1);  //mark ilp as long-term reference
-      m_bIsUsedAsLongTerm[REF_PIC_LIST_0][iOffset + i] = 1; //mark ilp as long-term reference
-      m_apcRefPicList[REF_PIC_LIST_0][iOffset + i] = pIlpPicList[i]; 
-      m_aiNumRefIdx[REF_PIC_LIST_0]++;
-      //m_aiNumRefIdx[REF_PIC_LIST_C]++;
-    }
-    if(m_eSliceType == B_SLICE)
-    {
-      m_aiNumRefIdx[REF_PIC_LIST_1] += iInsertOffset;
-      iOffset = m_aiNumRefIdx[REF_PIC_LIST_1];
-      for (Int i=0; i<iRefPicNum; i++)
-      {
-        pIlpPicList[i]->setIsLongTerm(1);  //mark ilp as long-term reference
-        m_bIsUsedAsLongTerm[REF_PIC_LIST_1][iOffset + i] = 1; //mark ilp as long-term reference
-        m_apcRefPicList[REF_PIC_LIST_1][iOffset + i] = pIlpPicList[i]; 
-        m_aiNumRefIdx[REF_PIC_LIST_1]++;
-        //m_aiNumRefIdx[REF_PIC_LIST_C]++;
-      }
-    }
-  }
-}
-
 #if REF_IDX_MFM
 Void TComSlice::setRefPOCListILP( TComPic** ilpPic, TComPic *pcRefPicBL )
@@ -2664,5 +2494,3 @@
 #endif
 
-
-#endif
 //! \}
Index: /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComSlice.h	(revision 161)
+++ /branches/SHM-2.0-dev/source/Lib/TLibCommon/TComSlice.h	(revision 162)
@@ -1388,5 +1388,5 @@
   Int         m_deblockingFilterBetaOffsetDiv2;    //< beta offset for deblocking filter
   Int         m_deblockingFilterTcOffsetDiv2;      //< tc offset for deblocking filter
-#if REF_LIST_BUGFIX
+#if REF_IDX_FRAMEWORK
   Int         m_aiNumILRRefIdx;       //< for inter-layer reference picture ser
 #endif
@@ -1538,5 +1538,5 @@
   Int       getDeblockingFilterBetaOffsetDiv2()         { return  m_deblockingFilterBetaOffsetDiv2; }
   Int       getDeblockingFilterTcOffsetDiv2()           { return  m_deblockingFilterTcOffsetDiv2; }
-#if REF_LIST_BUGFIX
+#if REF_IDX_FRAMEWORK
   Int       getNumILRRefIdx     ( )                     { return  m_aiNumILRRefIdx; }
   Void      setNumILRRefIdx     ( Int i )                     { m_aiNumILRRefIdx = i; }
@@ -1617,5 +1617,5 @@
 
 #if FIX1071
-  Void      setRefPicList       ( TComList<TComPic*>& rcListPic, Bool checkNumPocTotalCurr = false );
+  Void      setRefPicList       ( TComList<TComPic*>& rcListPic, Bool checkNumPocTotalCurr = false, TComPic** ilpPic = NULL );
 #else
   Void      setRefPicList       ( TComList<TComPic*>& rcListPic );
@@ -1627,7 +1627,6 @@
   Void      setMvdL1ZeroFlag     ( Bool b)                       { m_bLMvdL1Zero = b; }
 
-#if REF_LIST_BUGFIX
+#if REF_IDX_FRAMEWORK
   Void      setRefPicListModificationSvc();
-  Void      setRefPicListSvc    ( TComList<TComPic*>& rcListPic, TComPic** ilpPic );
 #endif
 
@@ -1746,7 +1745,4 @@
   Void      setEnableTMVPFlag     ( Bool   b )    { m_enableTMVPFlag = b; }
   Bool      getEnableTMVPFlag     ()              { return m_enableTMVPFlag;}
-#if REF_IDX_FRAMEWORK
-  Void      addRefPicList( TComPic **pIlpPicList, Int iRefPicNum, Int iInsertOffset=0 );
-#endif
 protected:
   TComPic*  xGetRefPic  (TComList<TComPic*>& rcListPic,
Index: /branches/SHM-2.0-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/SHM-2.0-dev/source/Lib/TLibCommon/TypeDef.h	(revision 161)
+++ /branches/SHM-2.0-dev/source/Lib/TLibCommon/TypeDef.h	(revision 162)
@@ -87,10 +87,4 @@
 #define ENCODER_FAST_MODE                1      ///< L0174: enable encoder fast mode. TestMethod 1 is enabled by setting to 1 and TestMethod 2 is enable by setting to 2. By default it is set to 1.
 #define REF_IDX_MFM                      1      ///< L0336: motion vector mapping of inter-layer reference picture
-
-#if REF_IDX_MFM
-#define RAP_MFM_INIT                     1      ///< initilizing MFM when base layer is RAP picture
-#endif
-#define REF_LIST_BUGFIX                  1
-
 #else
 #define INTRA_BL                         1      ///< inter-layer texture prediction